Subject: Re: [patch net-next RFC 0/4] introduce infrastructure for support of switch chip datapath

From: "John W. Linville" <[email-masked]>
Date: Wed, 2 Apr 2014 16:06:39 -0400

On Wed, Apr 02, 2014 at 12:54:50PM -0700, Scott Feldman wrote:
> 
> On Apr 2, 2014, at 12:29 PM, John W. Linville <[email-masked]> wrote:
> 
> > Cool!  I'm glad we agree.  Now we just need some switch hardware
> > drivers that fit the general model outlined above...
> 
> Why wait?  Let’s create a switch device in qemu and then write the
> model/sample driver to that.  Put a PCI front end on the qemu device
> which is mapped to kernel, and define a register set to represent all
> the switch-like ops we want to offload, in a generic way.  Throw in
> some DMA for CPU-bound I/O (ctrl traffic).  On the qemu device back
> end, expose the ports as taps or whatever so we can wire to real-world
> link partners on the host side.

Not a bad idea at all.  This probably needs further discussion and/or
a spec...and a QEMU hacker.  Where is my friend PJ when I need him? ;-)

> > I would be happy to maintain a kernel.org git tree as a nursery for
> > such drivers as they develop and mature, and I'm sure my daytime
> > employer would be happy to support me on that.  I wonder if we can
> > get any switch people from Intel, Mellanox, Broadcom, or elsewhere
> > to play along?
> 
> My gut tells me this is a build-it-and-they-will-come situation.

No doubt -- in the meantime, feel free to Cc me on some patches!

John
-- 
John W. Linville		Someday the world will need a hero, and you
[email-masked]			might be all we have.  Be ready.